from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, Boolean

Digestor_V0_1_0 = CommandToolBuilder(tool="Digestor", base_command=["Digestor"], inputs=[ToolInput(tag="in_in", input_type=File(optional=True), prefix="-in", doc=InputDocumentation(doc="*                  Input file (valid formats: 'fasta')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="*                 Output file (peptides) (valid formats: 'idXML', 'fasta')")), ToolInput(tag="in_out_type", input_type=File(optional=True), prefix="-out_type", doc=InputDocumentation(doc="Set this if you cannot control the filename of 'out', e.g., in TOPPAS. (valid: 'idXML', 'fasta')")), ToolInput(tag="in_missed_cleavages", input_type=Int(optional=True), prefix="-missed_cleavages", doc=InputDocumentation(doc="The number of allowed missed cleavages (default: '1' min: '0')")), ToolInput(tag="in_min_length", input_type=Int(optional=True), prefix="-min_length", doc=InputDocumentation(doc="Minimum length of peptide (default: '6')")), ToolInput(tag="in_max_length", input_type=Int(optional=True), prefix="-max_length", doc=InputDocumentation(doc="Maximum length of peptide (default: '40')")), ToolInput(tag="in_enzyme", input_type=Int(optional=True), prefix="-enzyme", doc=InputDocumentation(doc="The type of digestion enzyme (default: 'Trypsin' valid: 'Asp-N', 'Arg-C', 'Arg-C/P', 'Lys-C', 'Lys-N', 'no cleavage', 'unspecific cleavage', 'Formic_acid', 'Chymotrypsin/P', 'CNBr', 'Asp-N_ambic', 'Chymotrypsin', 'Lys-C/P', 'PepsinA', 'V8-DE', 'V8-E', 'Asp-N/B', 'Glu-C+P', 'PepsinA + P', 'leukocyte elastase', 'proline endopeptidase', 'glutamyl endopeptidase', 'Alpha-lytic protease', '2-iodobenzoate', 'iodosobenzoate', 'staphylococcal protease/D', 'proline-endopeptidase/HKR', 'cyanogen-bromide', 'Clostripain/P', 'elastase-trypsin-chymotrypsin', 'Trypsin', 'TrypChymo', 'Trypsin/P')")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="*                 Output file (peptides) (valid formats: 'idXML', 'fasta')")), ToolOutput(tag="out_out_type", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_type", type_hint=File()), doc=OutputDocumentation(doc="Set this if you cannot control the filename of 'out', e.g., in TOPPAS. (valid: 'idXML', 'fasta')"))], container="quay.io/biocontainers/openms:2.6.0--h4afb90d_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Digestor_V0_1_0().translate("wdl")

